Version = "1.0"
local orb = module.internal('orb')
local ts = module.internal('TS')
local pred = module.internal('pred')
local damage = module.internal('damage')

print("Illaoi by Argy")

menu = menu("Illaoi", "Illaoi")
menu:header("header", "Illaoi")
menu:menu("combo", "Combo Settings")
menu.combo:boolean("Q", "Use Q in Combo", true)
menu.combo:boolean("W", "Use W in Combo", true)
menu.combo:boolean("E", "Use E in Combo", true)
menu.combo:boolean("ER", "Use E to reset AA in Combo", true)
menu.combo:slider("Erange", "Min E Range", 600, 0, 900, 1)
menu:menu("ult", " ULT Settings")
menu.ult:boolean("R", "Use R in Combo", true)
menu:menu("harass", "Harass Settings")
menu.harass:boolean("Q", "Use Q in Combo", true)
menu.harass:boolean("W", "Use W in Combo", false)
menu.harass:boolean("E", "Use E in Combo", true)
menu.harass:slider("MQ", "If mana% >= X% [Q] enemy champ", 50, 0, 100, 1)
menu:menu("farm", "Farm Settings")
menu.farm:boolean("Q", "Use Q to Lane Clear", true)
menu.farm:boolean("QL", "Use Q to Lasthit", true)
menu.farm:boolean("W", "Use W to Lashit", true)
menu.farm:boolean("WL", "Use W to only Lasthit in Lane Clear", true)
menu.farm:slider("MQ", "If mana% >= X% use [Q] to lane clear", 30, 0, 100, 1)
menu:menu("draw", "Draw Settings")
menu.draw:boolean("qd", "Draw Q range", true)
menu.draw:boolean("wd", "Draw E range", true)
menu.draw:boolean("ed", "Draw E range", true)
menu.draw:boolean("rd", "Draw R range", true)

SpellQ = { delay = 0.75, range = 825, radius = 210 }
SpellW = { range = 350, radius = 350 }
SpellE = { delay = 0.25, range = 900, radius = 100 }
SpellR = { delay = 0.50, range = 450, radius = 450 }

Q = { 1.10, 1.15, 1.20, 1.25, 1.30 }
W = { 0.03, 0.035, 0.04, 0.045, 0.05 }
E = {}
R = { 150, 250, 350 }

Qdmg = 0
MinW = { 20, 30, 40, 50, 60 }
Wdmg = 0
Edmg = 0
Rdmg = 0

passive = ((player.levelRef * 10) + (player.totalAttackDamage * 1.2) + (player.totalAbilityPower * 0.40)) 

function drawRanges()
	if player.dead then return end

	graphics.draw_circle(player, player.attackRange + player.boundingRadius, -1, 0xffffffff)

	if menu.draw.qd:get() then
		graphics.draw_circle(player, SpellQ.range, -1, 0xffffffff)
	end

	if menu.draw.wd:get() then
		graphics.draw_circle(player, SpellW.range, -1, 0xffffffff)
	end

	if menu.draw.ed:get() then
		graphics.draw_circle(player, SpellE.range, -1, 0xffffffff)
	end

	if menu.draw.rd:get() then
		graphics.draw_circle(player, SpellR.range, -1, 0xffffffff)
	end
end
cb.add(cb.draw, drawRanges)

function checkMode()
	if orb.core.mode() == OrbwalkingMode.Combo then
		Combo()
	elseif orb.core.mode() == OrbwalkingMode.Mixed then
    	Harass()
	elseif orb.core.mode() == OrbwalkingMode.LaneClear then
    	LaneClear()
	elseif orb.core.mode() == OrbwalkingMode.LastHit then
		LastHit()
	elseif orb.core.mode() == OrbwalkingMode.Flee then
		Flee()
	end
end
cb.add(cb.tick, checkMode)

function DmgCal(obj, spellIndex)
	if spellIndex == 0 then
		Qlvl = (player:spellSlot(0).level)
		if player:spellSlot(0).level > 0 then
			Qdmg = (Q[Qlvl] * passive)
			if Qdmg > obj:totalHealth() then return true else return false end
		end	
	end
	if spellIndex == 1 then
		Wlvl = (player:spellSlot(1).level)
		if player:spellSlot(1).level > 0 then
			local bP = 0.02 * (player.totalAttackDamage//100)
			Wdmg = (obj.maxHealth * (W[Wlvl] + bP)) + player.totalAttackDamage
			if Wdmg < MinW[Wlvl] then
				Wdmg = MinW[Wlvl]
			end	
			if Wdmg > obj:totalHealth() then return true else return false end 
		end
	end	
	if spellIndex == 3 then
		Rlvl = (player:spellSlot(3).level)
		if player:spellSlot(3).level > 0 then
			Rdmg = ((R[Rlvl] + (player.totalBonusAttackDamage * 0.50)) + passive)
			if Rdmg > obj:totalHealth() then return true else return false end 
		end
	end		
end		

function LaneClear()
	local minCount = {}
	for minion in objManager.minions{ exclude_team = player.team, dist = SpellQ.range, valid_target = true } do
		minCount[#minCount + 1] = minion.pos
		if player:spellSlot(0).state == 0 and #minCount >= 3 and (player.mana / player.maxMana * 100. >= menu.farm.MQ:get()) then
			local seg = pred.linear.get_prediction(SpellQ, minion)
			if seg and #minCount >= 3 then
				player:castSpell('pos', SpellSlot.Q, seg.endPos)
			end
		end	
	end
	for minion in objManager.minions{ exclude_team = player.team, dist = SpellW.range, valid_target = true } do
		if player:spellSlot(1).state == 0 and not menu.farm.WL:get() then
				player:castSpell("obj", SpellSlot.W, minion)
		elseif player:spellSlot(1).state == 0 and menu.farm.WL:get() and DmgCal(minion, 1) then
			player:castSpell("obj", SpellSlot.W, minion)
		end	
	end	
end

function LastHit()
	for minion in objManager.minions{ exclude_team = player.team, dist = SpellQ.range, valid_target = true } do
		if player:spellSlot(0).state == 0 and menu.farm.QL:get() and DmgCal(minion, 0) then
			local seg = pred.linear.get_prediction(SpellQ, minion)
			if seg then
				player:castSpell('pos', SpellSlot.Q, seg.endPos)
			end
		end
	end		
	for minion in objManager.minions{ exclude_team = player.team, dist = SpellW.range, valid_target = true } do
		if player:spellSlot(1).state == 0 and menu.farm.W:get() and DmgCal(minion, 1) then
			player:castSpell("obj", SpellSlot.W, minion)
		end
	end		
end

function Combo()
	local enemiesInRange = {}
    for target in objManager.heroes{team = TEAM_ENEMY, valid_target = true, dist = 1000} do
		if target:dist() < SpellQ.range and player:spellSlot(0).state == 0 and menu.combo.Q:get() then
			local seg = pred.linear.get_prediction(SpellQ, target)
			if seg then
				player:castSpell('pos', 0, seg.endPos)
			end
		end
		if target:dist() < SpellW.range and player:spellSlot(1).state == 0 and menu.combo.W:get() then
			player:castSpell("obj", 1, target)
		end
		if target:dist() < SpellE.range and target:dist() >= menu.combo.Erange:get() and player:spellSlot(2).state == 0 and menu.combo.E:get() then
			local seg = pred.linear.get_prediction(SpellE, target)
			if seg then
				player:castSpell('pos', 2, seg.endPos)
			end
		end		
		if target:dist() < SpellR.range and player:spellSlot(3).state == 0 and menu.ult.R:get() and menu.ult.OR:get() and DmgCal(target, 3) then
			local seg = pred.circular.get_prediction(SpellR, target)
			if seg then
				player:castSpell('pos', 3, seg.endPos)
			end	
		end			
	end	
end

function Harass()
	for target in ts.get_targets() do
		if target:dist() < SpellQ.range and player:spellSlot(0).state == 0 and menu.harass.Q:get() then
			local seg = pred.linear.get_prediction(SpellQ, target)
			if seg then
				player:castSpell('pos', 0, seg.endPos)
			end
		end	
		if target:dist() < SpellW.range and player:spellSlot(1).state == 0 and menu.harass.W:get() then
			player:castSpell("obj", 1, target)
		end	
		if target:dist() < SpellE.range and player:spellSlot(2).state == 0 and menu.harass.E:get() then
			local seg = pred.linear.get_prediction(SpellE, target)
			if seg then
				player:castSpell('pos', 2, seg.endPos)
			end
		end
	end		
end

function Flee()
end	